package javacomp.basics;

import java.io.*;
import java.lang.reflect.*;
import java.net.*;
import java.util.*;

public class MultipleClassVersions
{
    private ArrayList<ClassVersionInterface> objects;

    public MultipleClassVersions()
    {
        objects = new ArrayList<ClassVersionInterface>();
    }
    
    public void redeploy() throws Exception
    {
        URL url = new File("hotdeployment/").toURI().toURL();
        URLClassLoader cl = new URLClassLoader(new URL[]{url});
        Class<?> newClassVersion = cl.loadClass("javacomp.basics.ClassVersion");
        ClassVersionInterface cv = (ClassVersionInterface) newClassVersion.newInstance();
        objects.add(cv);
    }
    
    public void showAllObjects()
    {
        int i = 0;
        for(ClassVersionInterface cv : objects)
        {
            i++;
            System.out.println("object no. " + i);
            cv.showMe();
            Class<?> c = cv.getClass();
            System.out.println("class: " + c.getName());
            System.out.print("attributes: ");
            Field[] fields = c.getDeclaredFields();
            for(Field f : fields)
            {
                System.out.print(f.getName()+ " ");
            }
            System.out.println();
            System.out.print("methods: ");
            Method[] methods = c.getDeclaredMethods();
            for(Method m : methods)
            {
                System.out.print(m.getName()+ " ");
            }
            System.out.println();
            System.out.println("-----------------------------");
        }
        System.out.println("-----------------------------");
    }

    public static void main(String[] args)
    {
        MultipleClassVersions mcv = new MultipleClassVersions();
        while(true)
        {
            try
            {
                mcv.redeploy();
                mcv.showAllObjects();
            }
            catch (Exception e)
            {
                System.err.println(e);
            }
            try
            {
                Thread.sleep(60000);
            }
            catch (Exception e)
            {
                System.err.println(e);
            }
        }
    }
}
