package javacomp.prototype.application2;

import javacomp.prototype.framework.ComponentContext;
import javacomp.prototype.framework.Start;
import javacomp.prototype.framework.Stop;

public class CounterService
{
    @Start
    public void start(ComponentContext ctx)
    {
        System.out.println("CounterService.start(ComponentContext)");
        Counter c1 = new Counter();
        ctx.bind("Counter1", c1);
        Counter c2 = new Counter(100);
        ctx.bind("Counter2", c2);
    }
    
    @Stop
    public void stop(ComponentContext ctx)
    {
        System.out.println("CounterService.stop(ComponentContext)");
        ctx.unbind("Counter1");
        ctx.unbind("Counter2");
    }
}
