package javacomp.javabeans;

import java.beans.*;
import java.util.ArrayList;

public class BeanWithBoundAndConstrainedProperty
{
    private String ourString;
    private ArrayList<PropertyChangeListener> changeListeners;
    private ArrayList<VetoableChangeListener> vetoListeners;

    public BeanWithBoundAndConstrainedProperty()
    {
        ourString = "hello";
        changeListeners = new ArrayList<PropertyChangeListener>();
        vetoListeners = new ArrayList<VetoableChangeListener>();
    }

    public String getOurString()
    {
        return ourString;
    }

    public void setOurString(String newString)
    {
        try
        {
            String oldString = ourString;
            PropertyChangeEvent event = new PropertyChangeEvent(this, "ourString",
                                                                oldString,
                                                                newString);
            for(VetoableChangeListener l: vetoListeners)
            {
                l.vetoableChange(event);
            }
            ourString = newString;
            for(PropertyChangeListener l: changeListeners)
            {
                l.propertyChange(event);
            }
        }
        catch (PropertyVetoException e)
        {
        }
    }

    public void addPropertyChangeListener(PropertyChangeListener l)
    {
        changeListeners.add(l);
    }

    public void removePropertyChangeListener(PropertyChangeListener l)
    {
        changeListeners.remove(l);
    }

    public void addVetoableChangeListener(VetoableChangeListener l)
    {
        vetoListeners.add(l);
    }

    public void removeVetoableChangeListener(VetoableChangeListener l)
    {
        vetoListeners.remove(l);
    }
}
