package javacomp.javabeans;

import java.beans.*;
import java.util.ArrayList;

public class BeanWithBoundProperty
{
    private String ourString;
    private ArrayList<PropertyChangeListener> listeners;
    //private PropertyChangeSupport changeSupport;

    public BeanWithBoundProperty()
    {
        ourString = "hello";
        listeners = new ArrayList<PropertyChangeListener>();
        //changeSupport = new PropertyChangeSupport(this);
    }

    public String getOurString()
    {
        return ourString;
    }

    public void setOurString(String newString)
    {
        String oldString = ourString;
        ourString = newString;
        PropertyChangeEvent event = new PropertyChangeEvent(this, "ourString",
                                                            oldString,
                                                            newString);
        for(PropertyChangeListener l: listeners)
        {
            l.propertyChange(event);
        }
        /*
        changeSupport.firePropertyChange("ourString",
                                         oldString,
                                         newString);
        */
    }

    public void addPropertyChangeListener(PropertyChangeListener l)
    {
        listeners.add(l);
        //changeSupport.addPropertyChangeListener(l);
    }

    public void removePropertyChangeListener(PropertyChangeListener l)
    {
        listeners.remove(l);
        //changeSupport.removePropertyChangeListener(l);
    }
}
