package javacomp.osgi.bundle5;

import javacomp.osgi.bundle0.Counter;
import org.osgi.service.component.ComponentContext;

public class CounterClient
{
    private CounterThread thread;

    protected void activate(ComponentContext cc)
    {
        System.out.println(getClass().getName() + ".activate");
    }

    protected void passivate(ComponentContext cc)
    {
        System.out.println(getClass().getName() + ".passivate");
    }

    protected void startCounterThread(Counter counter)
    {
        System.out.println(getClass().getName() +
                           ".startCounterThread");
        if(thread == null)
        {
            thread = new CounterThread(counter);
            thread.start();
        }
    }

    protected void stopCounterThread(Counter counter)
    {
        System.out.println(getClass().getName() +
                           ".stopCounterThread");
        if(thread != null)
        {
            thread.interrupt();
            thread = null;
        }
    }
}

class CounterThread extends Thread
{
    private Counter counter;
    
    public CounterThread(Counter counter)
    {
        this.counter = counter;
    }
    
    public void run()
    {
        System.out.println("Thread: " + counter.getClass().getName());
        try
        {
            while(!isInterrupted())
            {
                String output = counter.version() + " (" +
                                counter.increment() + ")";
                System.out.println(output);
                sleep(2000);
            }
        }
        catch(InterruptedException e)
        {
        }
    }
}
