package javacomp.eclipse.plugin1;

import org.eclipse.core.runtime.*;
import org.eclipse.swt.widgets.*;
import org.eclipse.ui.part.*;
import org.eclipse.ui.*;

public class CounterView extends ViewPart
{
    private static final String EXTENSION_POINT = "CounterView.functions";
    private static final String FUNCTION_NAME_ATTRIBUTE = "name";
    private static final String CLASS_ATTRIBUTE = "class";
    private static final String PARAMETERS_ATTRIBUTE = "parameters";

    public CounterView()
    {
        System.out.println("<<<CounterView>>>");
    }
    
    public void createPartControl(Composite parent)
    {
        FunctionsUserInterface ui = new FunctionsUserInterface(parent);
        Counter counter = new Counter();
        try
        {
            process(ui, counter);
        }
        catch(WorkbenchException e)
        {
            System.err.println(e.getMessage());
        }
    }

    public void setFocus()
    {
    }

    private void process(FunctionsUserInterface ui, Counter counter)
            throws WorkbenchException
    {
        IExtensionRegistry registry = Platform.getExtensionRegistry();
        IExtensionPoint extensionPoint = registry.getExtensionPoint(EXTENSION_POINT);
        if(extensionPoint == null)
        {
            throw new WorkbenchException("unable to resolve extension-point: " + EXTENSION_POINT);
        }
        IConfigurationElement[] members = extensionPoint.getConfigurationElements();

        for(IConfigurationElement member : members)
        {
            String functionName = member.getAttribute(FUNCTION_NAME_ATTRIBUTE);
            if(functionName == null)
            {
                functionName = "[namenlose Funktion]";
            }

            /*
            Object callback = null;
            try
            {
                callback = member.createExecutableExtension(CLASS_ATTRIBUTE);
                if(!(callback instanceof Function))
                {
                    System.err.println("callback function does not implement IFunction");
                    continue;
                }
            }
            catch(CoreException e)
            {
                System.err.println(e.getMessage());
                continue;
            }
            Function function = (Function)callback;
            */
            Function function = new FunctionProxy(member, CLASS_ATTRIBUTE);
            
            String parameters = member.getAttribute(PARAMETERS_ATTRIBUTE);
            if(parameters == null)
            {
                parameters = "";
            }
            ui.addFunction(functionName, function, parameters, counter);
        }
    }
}