package javacomp.eclipse.plugin1;

import org.eclipse.core.runtime.*;

class FunctionProxy implements Function
{
    private IConfigurationElement element;
    private String classAttribute;
    private Function realFunction = null;

    public FunctionProxy(IConfigurationElement element, String classAttribute)
    {
        this.element = element;
        this.classAttribute = classAttribute;
    }

    public int compute(int x, int[] params)
    {
        try
        {
            getRealFunction();
        }
        catch(Exception e)
        {
            System.err.println(e.getMessage());
            e.printStackTrace();
            throw new IllegalArgumentException("cannot get real function");
        }
        return realFunction.compute(x, params);
    }

    private void getRealFunction() throws Exception
    {
        if(realFunction != null)
        {
            return;
        }
        Object callback = element.createExecutableExtension(classAttribute);
        if(!(callback instanceof Function))
        {
            throw new Exception(classAttribute + " does not implement Function");
        }
        realFunction = (Function) callback;
    }
}
