package javacomp.eclipse.plugin1;

import org.eclipse.swt.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;

class FunctionRow
{
    protected Function function;
    protected Text result;
    protected Counter counter;
    protected Composite row;

    public FunctionRow(Composite main, Text result, String functionName,
                       Function function, Counter counter)
    {
        this.function = function;
        this.result = result;
        this.counter = counter;

        row = new Composite(main, SWT.None);
        RowLayout layout = new RowLayout();
        row.setLayout(layout);
        
        Button button = new Button(row, SWT.NONE);
        button.setText(functionName);
        ActionListener al = new ActionListener(this);
        button.addSelectionListener(al);
    }

    public void handleButton()
    {        
        int newValue = 0;
        try
        {
            newValue = function.compute(counter.getCounter(), new int[0]);
        }
        catch(IllegalArgumentException e)
        {
            System.err.println(e.getMessage());
        }
        counter.setCounter(newValue);
        result.setText("" + newValue);
    }
}
