package javacomp.eclipse.plugin1;

import org.eclipse.swt.*;
import org.eclipse.swt.widgets.*;

class FunctionRowWithParams extends FunctionRow
{
    private Text[] paramText;

    public FunctionRowWithParams(Composite main, Text result, String functionName,
                                 Function function, String parametersString, Counter counter)
    {
        super(main, result, functionName, function, counter);

        String[] rawParameters = parametersString.split(";");
        int numberOfRealParameters = 0;
        for(int i = 0; i < rawParameters.length; i++)
        {
            rawParameters[i] = rawParameters[i].trim();
            if(rawParameters[i].length() > 0)
            {
                numberOfRealParameters++;
            }
        }
        String[] parameters = new String[numberOfRealParameters];
        int j = 0;
        for(int i = 0; i < rawParameters.length; i++)
        {
            if(rawParameters[i].length() > 0)
            {
                parameters[j] = rawParameters[i];
                j++;
            }
        }
        paramText = new Text[parameters.length];
        for(int i = 0; i < parameters.length; i++)
        {
            Label l = new Label(row, SWT.None);
            l.setText(parameters[i] + ":");
            paramText[i] = new Text(row, SWT.None);
        }        
    }

    public void handleButton()
    {
        int[] params = new int[paramText.length];
        for(int i = 0; i < paramText.length; i++)
        {
            try
            {
                params[i] = Integer.parseInt(paramText[i].getText());
            }
            catch(NumberFormatException e)
            {
                System.err.println("no integer in parameter field no. " + (i+1));
                return;
            }
        }
        
        int newValue = 0;
        try
        {
            newValue = function.compute(counter.getCounter(), params);
        }
        catch(IllegalArgumentException e)
        {
            System.err.println(e.getMessage());
        }
        counter.setCounter(newValue);
        result.setText("" + newValue);
    }
}
