package javacomp.servlets.application1;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.annotation.*;

@WebServlet("/display")
public class DisplayServlet extends HttpServlet
{
    private static final long serialVersionUID = 7968546825609574805L;

    protected void doGet(HttpServletRequest request, HttpServletResponse response)
        throws IOException, ServletException
    {
        ServletContext myContext = getServletContext();
        Counter counter;
        synchronized(myContext)
        {
            counter = (Counter)myContext.getAttribute("counter");
            if(counter == null)
            {
                counter = new Counter();
                myContext.setAttribute("counter", counter);
            }
        }
        
        response.setContentType("text/html");
        PrintWriter out = response.getWriter();
        out.println("<html>");
        out.println("<head>");
        out.println("<title>Z&auml;hler</title>");
        out.println("</head>");
        out.println("<body>");
        out.println("<h1>Realisierung einer Z&auml;hleranwendung</h1>");
        out.println("Der aktuelle Stand des Z&auml;hlers ist " + 
                    counter.get() + ".");
        out.println("<p>");
        out.println("<form method=\"get\" action=\"" +
                    request.getContextPath() + "/increment\">");
        out.println("<input type=\"submit\" value=\"Erh&ouml;hen\"/>");
        out.println("</form>");
        out.println("<form method=\"get\" action=\"" + 
                    request.getContextPath() + "/reset\"/>");
        out.println("<input type=\"submit\" value=\"Zur&uuml;cksetzen\">");
        out.println("</form>");
        out.println("<form method=\"get\" action=\"" + 
                    request.getContextPath() + "/set\"/>");
        out.println("<input type=\"text\" name=\"newValue\">");
        out.println("<input type=\"submit\" value=\"Setzen\">");
        out.println("</form>");
        out.println("</body>");
        out.println("</html>");        
    }
}
