package javacomp.servlets.application1;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.annotation.*;

@WebServlet("/reset")
public class ResetServlet extends HttpServlet
{
    private static final long serialVersionUID = 7968546825609574805L;

    protected void doGet(HttpServletRequest request, HttpServletResponse response)
        throws IOException, ServletException
    {
        ServletContext myContext = getServletContext();
        Counter counter;
        synchronized(myContext)
        {
            counter = (Counter)myContext.getAttribute("counter");
            if(counter == null)
            {
                counter = new Counter();
                myContext.setAttribute("counter", counter);
            }
        }
        counter.reset();
        
        RequestDispatcher dispatcher = myContext.getRequestDispatcher("/display");
        dispatcher.forward(request, response);
    }
}
