package javacomp.servlets.application1;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.annotation.*;

@WebServlet("/set")
public class SetServlet extends HttpServlet
{
    private static final long serialVersionUID = 7968546825609574805L;

    protected void doGet(HttpServletRequest request, HttpServletResponse response)
        throws IOException, ServletException
    {
        boolean inputOkay = false;
        int newValue = 0;
        String newValueString = request.getParameter("newValue");
        if(newValueString != null)
        {
            try
            {
                newValue = Integer.parseInt(newValueString);
                inputOkay = true;
            }
            catch(NumberFormatException e)
            {
            }
        }
                
        ServletContext myContext = getServletContext();
        Counter counter;
        synchronized(myContext)
        {
            counter = (Counter)myContext.getAttribute("counter");
            if(counter == null)
            {
                counter = new Counter();
                myContext.setAttribute("counter", counter);
            }
        }

        if(inputOkay)
        {
            counter.set(newValue);
        }

        RequestDispatcher dispatcher = myContext.getRequestDispatcher("/display");
        dispatcher.forward(request, response);
    }
}
