package javacomp.servlets.application2;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.annotation.*;
import javacomp.servlets.application1.Counter;

@WebServlet("/decrement")
public class DecrementServlet extends HttpServlet
{
    private static final long serialVersionUID = 7968546825609574805L;

    protected void doGet(HttpServletRequest request, HttpServletResponse response)
        throws IOException, ServletException
    {
        ServletContext myContext = getServletContext();
        ServletContext otherContext = myContext.getContext("/application1");
        Counter counter;
        synchronized(otherContext)
        {
            counter = (Counter)otherContext.getAttribute("counter");
            if(counter == null)
            {
                counter = new Counter();
                otherContext.setAttribute("counter", counter);
            }
        }
        counter.decrement();
        
        RequestDispatcher dispatcher = otherContext.getRequestDispatcher("/display");
        dispatcher.forward(request, response);
    }
}
