package javacomp.ejb.counter.client;

import java.util.Properties;
import javacomp.ejb.counter.server.*;
import javax.naming.*;

public class CounterClient
{
    public static void main(String[] args) throws Exception
    {
    	Properties properties = new Properties();
        properties.put(Context.INITIAL_CONTEXT_FACTORY,
                       "org.jnp.interfaces.NamingContextFactory");
        properties.put(Context.PROVIDER_URL,
                       "localhost:1099");
        Context context = new InitialContext(/*properties*/);
        if(args.length != 2)
        {
        	usage();
        }
        
        String beanName = args[0];
        Counter counter1 = (Counter)context.lookup(beanName);
        Counter counter2 = (Counter)context.lookup(beanName);
        
        int number = 0;
        try
        {
            number = Integer.parseInt(args[1]);
        }
        catch(NumberFormatException e)
        {
        	usage();
        }

        for(int i = 0; i < number; i++)
        {
        	int newValue1 = counter1.increment();
        	int newValue2 = counter2.increment();
        	System.out.println(newValue1 + " " + newValue2);
        }
        counter1.bye();
        counter2.bye();
        //System.out.println("reset: value = " + counter1.reset());
    }
    
    private static void usage()
    {
    	System.out.println("2 args required: bean_name number");
    	System.exit(0);
    }
}