package javacomp.ejb.person.server;

import javax.ejb.Stateless;
import javax.persistence.*;

@Stateless(mappedName="PersonManager")
public class PersonManagerImpl implements PersonManager
{
	@PersistenceContext 
	private EntityManager em;

    public int createPerson(String firstName, String secondName)
    {
        Person person = new Person();
        person.setFirstName(firstName);
        person.setSecondName(secondName);
        em.persist(person);
        return person.getId();
    }

    public Person findPerson(int id)
    {
        return em.find(Person.class, id);
    }

    public Person updatePerson(int id, String firstName, String secondName)
    {
        Person person = findPerson(id);
        if (person != null)
        {
            person.setFirstName(firstName);
            person.setSecondName(secondName);
        }
        return person;
    }
    
    public boolean removePerson(int id)
    {
        Person person = findPerson(id);
    	if(person == null)
    	{
    		return false;
    	}
    	em.remove(person);
    	return true;
    }
}
