package javacomp.ejb.person.client;

import javacomp.ejb.person.server.*;

import javax.naming.InitialContext;

public class PersonClient
{
    public static void main(String[] args) throws Exception
    {
        InitialContext context = new InitialContext();
        PersonManager pm = (PersonManager) context.lookup("PersonManager");
        if (args.length > 0)
        {
            if (args[0].equals("create") && args.length == 3)
            {
                int id = pm.createPerson(args[1], args[2]);
                System.out.println(id);
                return;
            }
            else if (args[0].equals("find") && args.length == 2)
            {
                Person person = pm.findPerson(Integer.parseInt(args[1]));
                if (person != null)
                {
                    System.out.println(person.getFirstName() + " " + person.getSecondName());
                }
                else
                {
                    System.out.println("No person found.");
                }
                return;
            }
            else if (args[0].equals("update") && args.length == 4)
            {
                Person person = pm.updatePerson(Integer.parseInt(args[1]), args[2], args[3]);
                if (person != null)
                {
                    System.out.println("Person: " + person.getFirstName() + " " + person.getSecondName());
                }
                else
                {
                    System.out.println("No person found.");
                }
                return;
            }
            else if (args[0].equals("remove") && args.length == 2)
            {
            	int id = Integer.parseInt(args[1]);
                boolean success = pm.removePerson(id);
                if (success)
                {
                    System.out.println("Person with id " + id + " removed.");
                }
                else
                {
                    System.out.println("No person found.");
                }
                return;
            }
        }
        System.out.println("Arguments:\n" +
             "    create <first name> <second name>\n" +
             "    find <id>\n" +
             "    update <id> <first name> <second name>\n" +
             "    remove <id>");
    }
}
