package javacomp.ejb.sleep.server;

import javax.annotation.*;
import javax.ejb.*;

@Singleton(mappedName="SingletonSleep")
@ConcurrencyManagement(ConcurrencyManagementType.CONTAINER)
public class SingletonSleepImpl implements Sleep
{
	//@Lock(LockType.READ)
    public void sleep(int secs)
    {
    	System.out.println("sleep(" + secs + ") begin");
    	try
    	{
			Thread.sleep(secs * 1000);
		}
    	catch (InterruptedException e)
    	{
		}
    	System.out.println("sleep(" + secs + ") end");
	}
	
    @PostConstruct
    public void constructor()
    {
        System.out.println("created: " + getClass().getName());
    }
	
    @PreDestroy
    public void destructor()
    {
        System.out.println("will be removed: " + getClass().getName());
    }
}
