package javacomp.ejb.sleep.server;

import javax.annotation.*;
import javax.ejb.Stateful;

@Stateful(mappedName="StatefulSleep")
public class StatefulSleepImpl implements Sleep
{
	private static int globalCounter;
	private int counter;
	
    public void sleep(int secs)
    {
    	System.out.println("sleep(" + secs + ") begin <" + counter + ">");
    	try
    	{
			Thread.sleep(secs * 1000);
		}
    	catch (InterruptedException e)
    	{
		}
    	System.out.println("sleep(" + secs + ") end <" + counter + ">");
	}
	
    @PostConstruct
    public void constructor()
    {
    	globalCounter++;
    	counter = globalCounter;
        System.out.println("created: " + getClass().getName() +
        		           "<" + counter + ">");
    }
	
    @PreDestroy
    public void destructor()
    {
        System.out.println("will be removed: " + getClass().getName());
    }
}
