package javacomp.spring.annoaop;

import org.aspectj.lang.*;
import org.aspectj.lang.annotation.*;

@Aspect
public class LoggingAroundAdvice
{
    @Around("execution(* *(..))")
    public Object m(ProceedingJoinPoint pjp) throws Throwable
    {
        String message = pjp.getStaticPart().toLongString();
        System.out.println("vor " + message);
        Object result;
        try
        {
            result = pjp.proceed(); 
        }
        catch(Throwable t)
        {
            System.out.println("Ausnahme in " + message);
            throw t;
        }
        System.out.println("nach " + message);
        return result;
    }
}
