package javacomp.spring.annoconfig;

import javacomp.spring.counter.Counter;
import javacomp.spring.hello.Hello;
import org.springframework.context.*;
import org.springframework.context.annotation.*;

public class HelloApp
{
    public static void main(String[] args) throws Exception
    {
        ApplicationContext context = 
            new AnnotationConfigApplicationContext(HelloConfig.class);
        
        if(args.length == 0)
        {
            Hello hello = context.getBean("hello", Hello.class);
            hello.sayGreeting("Welt");
        }
        else
        {
            for(String arg: args)
            {
                Hello hello = context.getBean("hello", Hello.class);
                hello.sayGreeting(arg);
            }
        }
        Counter counter = context.getBean("zaehler", Counter.class);
        System.out.println("counter = " + counter.get());
    }
}
