package javacomp.spring.aop;

import java.lang.reflect.*;

import org.springframework.aop.*;

public class LoggingAfterReturningAdvice implements AfterReturningAdvice
{
    public void afterReturning(Object result, Method m,
                               Object[] args, Object target)
        throws Throwable
    {
        String message =
            "Aufruf von " + target.getClass().getName() +
            "." + m.getName() + "(";
        for(int i = 0; i < args.length; i++)
        {
            message += args[i];
            if(i < args.length - 1)
            {
                message += ", ";
            }
        }
        message += ")";
        System.out.println("nach " + message +
                           " => " + result);
    }
}
