package javacomp.spring.aop;

import java.lang.reflect.*;
import org.aopalliance.intercept.*;

public class LoggingInterceptorAdvice implements MethodInterceptor
{
    public Object invoke(MethodInvocation invocation)
        throws Throwable
    {
        Object target = invocation.getThis();
        Method m = invocation.getMethod();
        Object[] args = invocation.getArguments();
        String message =
            "Aufruf von " + target.getClass().getName() +
            "." + m.getName() + "(";
        for(int i = 0; i < args.length; i++)
        {
            message += args[i];
            if(i < args.length - 1)
            {
                message += ", ";
            }
        }
        message += ")";
        System.out.println("vor " + message);
        Object result;
        try
        {
            result = invocation.proceed();
        }
        catch(Throwable t)
        {
            System.out.println("Ausnahme " + t + " in " + message);
            throw t;            
        }
        if(m.getReturnType()==void.class)
        {
            System.out.println("nach " + message);
        }
        else
        {
            System.out.println("nach " + message + " => " + result);
        }
        return result;
    }
}
