package javacomp.spring.postprocessor;

import javacomp.spring.counter.Counter;
import javacomp.spring.hello.Hello;
import org.springframework.beans.BeansException;
import org.springframework.beans.factory.config.*;

public class ExamplePostProcessor implements BeanPostProcessor
{
    public Object postProcessBeforeInitialization(Object bean,
                                                  String name)
        throws BeansException
    {
        return bean;
    }

    public Object postProcessAfterInitialization(Object bean,
                                                 String name)
        throws BeansException
    {
        System.out.println("nach Initialisierung von " + name);
        if(bean instanceof Hello)
        {
            Hello h = (Hello) bean;
            h.setGreeting("Hallo hallo");
        }
        else if(bean instanceof Counter)
        {
            return new DoubleCounter();
        }
        return bean;
    }
}
