package javacomp.eventbus.counter;

import java.util.Collection;
import org.rribbit.*;
import org.rribbit.creation.*;

public class CounterApp
{
    public static void main(String[] args) throws Exception
    {
        Counter c1 = new Counter();
        Counter c2 = new Counter();
        DoubleCounter c3 = new DoubleCounter();
        DoubleCounter c4 = new DoubleCounter();
        DoubleCounter c5 = new DoubleCounter();
        ListenerObjectCreator creator =
            new ObjectBasedListenerObjectCreator(c1, c2, c3, c4, c5);
        /*
        ListenerObjectCreator creator =
            new InstantiatingClassBasedListenerObjectCreator(Counter.class, DoubleCounter.class);
        */
        RequestResponseBus bus =
            RRiBbitUtil.createRequestResponseBusForLocalUse(creator, true);
        //new SendingThread().start();
        for(int i = 0; i < 10; i++)
        {
            int value = bus.send("increment");
            System.out.println("" + value);
        }
        for(int i = 0; i < 10; i++)
        {
            Collection<Integer> values = bus.sendForMultipleWithHint("increment");
            System.out.println("" + values);
        }        
    }
}

class SendingThread extends Thread
{
    public void run()
    {
        RequestResponseBus bus = RRB.get();
        for(int i = 0; i < 10; i++)
        {
            int value = bus.send("increment");
            System.out.println("" + value);
        }
    }
}
