package javacomp.android.unboundservice;

import android.app.Service;
import android.content.Intent;
import android.os.IBinder;
import android.util.Log;

public class MyUnboundService extends Service
{
    private static int instanceCounter = 0;

    private int number;

    public MyUnboundService()
    {
        instanceCounter++;
        number = instanceCounter;
    }

    @Override
    public IBinder onBind(Intent intent)
    {
        return null;
    }

    @Override
    public void onCreate()
    {
        // Toast.makeText(this, "My Service Created", Toast.LENGTH_LONG).show();
        Log.d(this.getClass().getName(), "onCreate (" + number + " / "
                + android.os.Process.myPid() + "-"
                + Thread.currentThread().getName() + ")");
    }

    @Override
    public void onDestroy()
    {
        // Toast.makeText(this, "My Service Stopped", Toast.LENGTH_LONG).show();
        Log.d(this.getClass().getName(), "onDestroy (" + number + " / "
                + android.os.Process.myPid() + "-"
                + Thread.currentThread().getName() + ")");
    }

    @Override
    public int onStartCommand(Intent intent, int flags, int startid)
    {
        // Toast.makeText(this, "My Service Started", Toast.LENGTH_LONG).show();
        Log.d(this.getClass().getName(), "onStartCommand (" + number + " / "
                + android.os.Process.myPid() + "-"
                + Thread.currentThread().getName() + ")");
        new ServiceThread().start();
        return START_STICKY;
    }
}

class ServiceThread extends Thread
{
    public void run()
    {
        for (int i = 1; i <= 10; i++)
        {
            Log.d(this.getClass().getName(), "service with thread " + getName()
                    + ", iteration no. " + i);
            try
            {
                Thread.sleep(2000);
            } catch (InterruptedException e)
            {
            }
        }
    }
}