package javacomp.android.boundservice;

import android.os.Handler;
import android.os.RemoteException;
import android.util.Log;
import android.widget.TextView;

public class CallbackImpl extends Callback.Stub
{
    private Handler handler;
    private TextView tv;

    public CallbackImpl(Handler handler, TextView tv)
    {
        this.handler = handler;
        this.tv = tv;
    }

    public void newCounterValue(int newValue) throws RemoteException
    {
        Log.d(this.getClass().getName(), "sendMessage has been called (" +
                                          android.os.Process.myPid() + "-" +
                                          Thread.currentThread().getName() + ")");
        Runner r = new Runner(tv, newValue);
        handler.post(r);
    }
}

class Runner implements Runnable
{
    private TextView tv;
    private int newValue;

    public Runner(TextView tv, int newValue)
    {
        this.tv = tv;
        this.newValue = newValue;
    }

    public void run()
    {
        Log.d(this.getClass().getName(), "updating text field (" +
                                         android.os.Process.myPid() + "-" +
                                         Thread.currentThread().getName() + ")");
        tv.setText("neuer Wert: " + newValue);
    }
}