package javacomp.android.bindservice1;

import android.os.Handler;
import android.os.RemoteException;
import android.util.Log;
import android.widget.TextView;

public class CallbackImpl extends Callback.Stub
{
	private Handler handler;
	private TextView tv;
	
	public CallbackImpl(Handler handler, TextView tv)
	{
		this.handler = handler;
		this.tv = tv;
	}

	public void sendMessage(String msg) throws RemoteException
	{
        Log.d(this.getClass().getName(), "sendMessage has been called (" + android.os.Process.myPid() + "-" + Thread.currentThread().getName() + ")");
		Runner r = new Runner(tv, msg);
		handler.post(r);
	}
}

class Runner implements Runnable
{
	private TextView tv;
	private String msg;

	public Runner(TextView tv, String msg) 
	{
		this.tv = tv;
		this.msg = msg;
	}

	public void run() 
	{
        Log.d(this.getClass().getName(), "updating text field (" + android.os.Process.myPid() + "-" + Thread.currentThread().getName() + ")");
		tv.setText(msg);
	}
	
}