package javacomp.android.bindservice1;

import android.os.RemoteException;
import android.util.Log;

public class CounterImpl extends Counter.Stub
{
	private int counter;
	
	public synchronized int increment() throws RemoteException
	{
        Log.d(this.getClass().getName(), "increment has been called (" + android.os.Process.myPid() + "-" + Thread.currentThread().getName() + ")");
		counter++;
		return counter;
	}

	public synchronized int reset() throws RemoteException
	{
        Log.d(this.getClass().getName(), "reset has been called (" + android.os.Process.myPid() + "-" + Thread.currentThread().getName() + ")");
		counter = 0;
		return counter;
	}

	public synchronized void change(Data data) throws RemoteException 
	{
        Log.d(this.getClass().getName(), "change has been called (" + android.os.Process.myPid() + "-" + Thread.currentThread().getName() + ")");
		counter = counter * data.getFactor() + data.getAddend();
		data.setResult(counter);
	}

	public void callbackMethod(Callback cb) throws RemoteException
	{
        Log.d(this.getClass().getName(), "callback has been called (" + android.os.Process.myPid() + "-" + Thread.currentThread().getName() + ")");
		new CallbackThread(cb).start();
	}
}

class CallbackThread extends Thread
{
	private Callback cb;

	public CallbackThread(Callback cb) 
	{
		this.cb = cb;
	}
	
	public void run()
	{
		String msg = "*";
		for(int i = 0; i < 10; i++)
		{
			try
			{
		        Log.d(this.getClass().getName(), "calling callback method sendMessage (" + android.os.Process.myPid() + "-" + Thread.currentThread().getName() + ")");
				cb.sendMessage(msg);
				sleep(2000);
				msg += "*";
			}
			catch(Exception e)
			{
			}
		}
	}
}