package javacomp.android.bindservice1;

import android.content.ComponentName;
import android.content.ServiceConnection;
import android.os.IBinder;
import android.util.Log;

public class MyServiceConnection implements ServiceConnection
{
	private ServiceActivity activity;
	
	public MyServiceConnection(ServiceActivity activity)
	{
		this.activity = activity;
	}

	public void onServiceConnected(ComponentName name, IBinder binder)
	{
        Log.d(this.getClass().getName(), "service connected (" + android.os.Process.myPid() + "-" + Thread.currentThread().getName() + ")");
		Counter c = Counter.Stub.asInterface(binder);
		activity.setCounter(c);
	}

	public void onServiceDisconnected(ComponentName name)
	{
        Log.d(this.getClass().getName(), "service disconnected (" + android.os.Process.myPid() + "-" + Thread.currentThread().getName() + ")");
		activity.setCounter(null);
	}
}
